from machine import Pin
import time

# Setup
button = Pin(4, Pin.IN, Pin.PULL_UP)     # Button on GPIO5 with internal pull-up
relay = Pin(16, Pin.OUT)                 # Relay on GPIO16

relay_state = False                      # Initial state of relay (OFF)
last_button_state = 1                    # Previous reading from button (not pressed)

print("Toggle relay with button...")

while True:
    current_state = button.value()
    
    if last_button_state == 1 and current_state == 0:  # Button press detected (active low)
        relay_state = not relay_state                 # Toggle relay state
        relay.value(relay_state)                      # Apply new state to relay
        print("Relay ON" if relay_state else "Relay OFF")
        time.sleep(0.2)  # Debounce delay

    last_button_state = current_state
    time.sleep(0.01)     # Loop delay
